require 'uri'
require 'mastercard_core_sdk'
require_relative '../../mastercard_merchant_checkout/models/pairing'
 

module MastercardMerchantCheckout
 module Api

  class PairingIdApi
    include MastercardCoreSdk::Core, MastercardCoreSdk::Client, MastercardCoreSdk::Exceptions
	  include MastercardMerchantCheckout::Tracker


    # PairingId Service
    # Use this service to get a consumer’s pairing identifier from Masterpass when they choose to share the payment and shipping information from their Masterpass wallet for future use in an Express Checkout. API URL: /masterpass/pairingid
    # @param query_params The query parameters.
    # @param api_config Optional ApiConfig object specifying configuration : consumer key, private key, host URL. 
    # @return [Pairing]
    def self.show(query_params, api_config = nil)
		 path = "/masterpass/pairingid"
	 	 service_request = ServiceRequest.new
     
	   
	 service_request.query_params = query_params
	   service_request.content_type = "application/json"
	   api_client = ApiClient.new(api_config)
     api_client.api_tracker = SdkApiTracker.new
     api_client.error_handler = ErrorHandler.new
	   return api_client.call(path, service_request, "GET",Pairing)
    end

  end

 end
end



