require 'uri'
require 'mastercard_core_sdk'
require_relative '../../mastercard_merchant_checkout/models/postback'
 

module MastercardMerchantCheckout
 module Api

  class PostbackApi
    include MastercardCoreSdk::Core, MastercardCoreSdk::Client, MastercardCoreSdk::Exceptions
	  include MastercardMerchantCheckout::Tracker


    # Postback Service
    # This is the final step in the transaction and reports the result of their transactions to Masterpass. Postback is required for all transactions (abandoned transactions do not need to be reported). API URL: /masterpass/postback
    # @param postback This is the merchant&#39;s transaction details.

    # @param api_config Optional ApiConfig object specifying configuration : consumer key, private key, host URL. 
    # @return [nil]
    def self.create(postback, api_config = nil)
		 path = "/masterpass/postback"
	 	 service_request = ServiceRequest.new
     
	   
	   service_request.body = postback
	 
	   service_request.content_type = "application/json"
	   api_client = ApiClient.new(api_config)
     api_client.api_tracker = SdkApiTracker.new
     api_client.error_handler = ErrorHandler.new
	   return api_client.call(path, service_request, "POST",nil)
    end

  end

 end
end



