require 'uri'
require 'mastercard_core_sdk'
require_relative '../../mastercard_merchant_checkout/models/pre_checkout_data'
 

module MastercardMerchantCheckout
 module Api

  class PreCheckoutDataApi
    include MastercardCoreSdk::Core, MastercardCoreSdk::Client, MastercardCoreSdk::Exceptions
	  include MastercardMerchantCheckout::Tracker


    # PreCheckout Data Service
    # Use the consumer’s pairingID to retrieve their shipping and payment information prior to complete an Express Checkout.  You can use the data returned from this service to confirm the user’s payment selections before completing the checkout. API URL: /masterpass/precheckoutdata/{pairingId}
    # @param pairing_id The unique pairing token identifier used to fetch pre-checkout data for a wallet that is paired with a merchant.

    # @param api_config Optional ApiConfig object specifying configuration : consumer key, private key, host URL. 
    # @return [PreCheckoutData]
    def self.show(pairing_id, api_config = nil)
		 path = "/masterpass/precheckoutdata/{pairingId}"
	 	 service_request = ServiceRequest.new
     service_request.path_params["pairingId"] = pairing_id
	 
	   
	 
	   service_request.content_type = "application/json"
	   api_client = ApiClient.new(api_config)
     api_client.api_tracker = SdkApiTracker.new
     api_client.error_handler = ErrorHandler.new
	   return api_client.call(path, service_request, "GET",PreCheckoutData)
    end

  end

 end
end



