require 'date'
require 'roxml'
 

module MastercardMerchantCheckout
  # The contact info details for the wallet user.
  class ContactInfo
    include ROXML
    
    xml_name "ContactInfo"
    
    # @!attribute first_name
    # @return [String] the first name associated with the wallet user.
    xml_accessor :first_name, :from =>"firstName"
   
    # @!attribute last_name
    # @return [String] the last name associated with the wallet user.
    xml_accessor :last_name, :from =>"lastName"
   
    # @!attribute country
    # @return [String] the country associated with the wallet user.
    xml_accessor :country, :from =>"country"
   
    # @!attribute email_address
    # @return [String] the email address associated with the wallet user.
    xml_accessor :email_address, :from =>"emailAddress"
   
    # @!attribute phone_number
    # @return [String] the phone number associated with the wallet user.
    xml_accessor :phone_number, :from =>"phoneNumber"
   

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :first_name => :firstName ,
        :last_name => :lastName ,
        :country => :country ,
        :email_address => :emailAddress ,
        :phone_number => :phoneNumber 
        
      }
    end

    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes.has_key?(:first_name)
        self.first_name = attributes[:first_name]
      end
      
      if attributes.has_key?(:last_name)
        self.last_name = attributes[:last_name]
      end
      
      if attributes.has_key?(:country)
        self.country = attributes[:country]
      end
      
      if attributes.has_key?(:email_address)
        self.email_address = attributes[:email_address]
      end
      
      if attributes.has_key?(:phone_number)
        self.phone_number = attributes[:phone_number]
      end
      
    end
    
 
	

    # Check equality by comparing each attribute.
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          first_name == o.first_name &&
          last_name == o.last_name &&
          country == o.country &&
          email_address == o.email_address &&
          phone_number == o.phone_number
    end

    # @see the `==` method
    def eql?(o)
      self == o
    end

    # Calculate hash code according to all attributes.
    def hash
      [first_name, last_name, country, email_address, phone_number].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.datatype_map.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :Object
      	value
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k).to_sym] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = MastercardMerchantCheckout.const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash(include_root = false)
      attributes_hash = {} 
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      attributes_hash = include_root ? { "ContactInfo" => hash } : hash  
      return attributes_hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end


    private
    def after_parse
      self.send(:remove_instance_variable, :@roxml_references) if defined? self.roxml_references
    end
    
    # Attribute datatype mapping.
    def self.datatype_map
      {
        :first_name => 'String',
        :last_name => 'String',
        :country => 'String',
        :email_address => 'String',
        :phone_number => 'String'
        
      }
    end
  end


end
